#include <stdio.h>
#include "MathFunctions.h"

// a hack square root calculation using simple operations
double mysqrt(double x)
{
  if (x <= 0)
    {
    return 0;
    }

  double result;
  // if we have both log and exp then use them
#if defined(HAVE_LOG) && defined (HAVE_EXP)
	result = exp(log(x)*0.5);
	fprintf(stdout,"mysqrt.cxx - 正在使用 log 計算 %g 的平方根為 %g\n",x,result);
#else
  double delta;
  result = x;

  // do ten iterations
  int i;
  for (i = 0; i < 10; ++i)
    {
    if (result <= 0)
      {
      result = 0.1;
      }
    delta = x - (result*result);
    result = result + 0.5*delta/result;
    fprintf(stdout,"mysqrt.cxx - 正在計算 %g 的平方根為 %g\n",x,result);
    }
#endif
  return result;
}
